import os
from distutils.core import setup, Extension

temp_includes = os.popen("pkg-config --cflags dbus-1 glib-2.0").read().replace("-I","").split()
temp_includes.append("../utils")
temp_includes.append("../bus")
temp_includes.append("../../.")

source_files = ['incop_wrap.c', 'incop.c','flowpool.c','connection.c','signature.c','protocol.c']
source_files = source_files + ['privatecallbacks.c','packetdecoder.c','system.c','detection.c']
source_files = source_files + ['../bus/incopdbus.c','payload.c','packet.c']

incop_module = Extension('_incop',
	sources = source_files,
	include_dirs = temp_includes,
#	library_dirs = [ '../opcodes/.libs'],
	libraries = ['glib-2.0','pcap','dbus-1','log4c'],
	define_macros=[('HAVE_LIBDBUS_1','1'),('HAVE_CONFIG','1')],
	#define_macros=[('HAVE_LIBDBUS_1','1'),('PACKAGE','\"test\"'),('PCRE_HAVE_JIT','0'),('__LINUX__','1'),('PACKAGE_BUGREPORT','test')],
	#define_macros=[('HAVE_LIBDBUS_1','1'),('DEBUG0','1')],
	#define_macros=[('HAVE_LIBDBUS_1','1'),('DEBUG0','1'),('DEBUG1','1')],
#        define_macros=[('DEBUG', '1')],
	)

setup (name = 'incop',
       version = '0.1',
       author      = "Luis Campo Giralte",
       description = """Simple wrapper for the InCoP engine""",
       ext_modules = [incop_module],
       py_modules = ["incop"],
       )

