import os
from distutils.core import setup, Extension

temp_includes = os.popen("pkg-config --cflags dbus-1 glib-2.0").read().replace("-I","").split()
temp_includes.append("../src/utils")
temp_includes.append("../src/bus")
temp_includes.append("../src/core")
temp_includes.append("../../.")
temp_includes.append("../.")

source_files = ['incop_test_wrap.c', '../src/core/flowpool.c','../src/core/connection.c','../src/core/signature.c']
source_files = source_files + ['../src/core/payload.c','../src/core/protocol.c']
#source_files = source_files + ['../bus/incopdbus.c']

incop_test_module = Extension('_incop_test',
	sources = source_files,
	include_dirs = temp_includes,
	libraries = ['glib-2.0','pcap','dbus-1','log4c','ssl'],
	define_macros=[('HAVE_LIBDBUS_1','1'),('HAVE_CONFIG','1')],
	)

setup (name = 'incop_test',
       version = '0.1',
       author      = "Luis Campo Giralte",
       description = """Simple wrapper for the InCoP engine""",
       ext_modules = [incop_test_module],
       py_modules = ["incop_test"],
       )

